/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.Test;

import com.strategyquant.lib.results.SQResult;
import com.strategyquant.lib.results.SQResultsGroup;
import com.strategyquant.lib.results.SQStats;
import com.strategyquant.lib.scripter.Program;
import com.strategyquant.lib.settings.SQConst;
import com.strategyquant.lib.tests.TestScript;


public class EAALoaderTradestation extends TestScript {
	public EAALoaderTradestation() {
		setCategory("EAA Loaders");
		setName("EAA Loader Tradestation");
	}
	
	@Override
	public void runTest() {
		testMht();
		testMht2();
		testXml();
	}
	
	public void testMht() {
		
		try {
			SQResultsGroup strategyResults = (SQResultsGroup) Program.get("Loader").call("loadFile", "./tests/data/loaders/ts_report.mht");
			SQResult result;
			SQStats stats;
			
			// verify that correct loader was used
			//assertEquals("TradestationWebReportLoader", loader.getPluginLoaderUsed());
			
			// verify portfolio
			result = strategyResults.getResult(SQConst.SYMBOL_PORTFOLIO);
			stats = result.getStats(SQConst.DIRECTION_ALL, SQConst.PL_IN_MONEY, SQConst.KEY_SAMPLE_ALL);
		
			assertEquals("MHT 1 NumberOfTrades", 3173, stats.getInt("NumberOfTrades"));

			
		} catch (Exception e) {
			fail("Exception "+ e.getMessage());
		}
	}
	
	public void testMht2() {
		
		try {
			SQResultsGroup strategyResults = (SQResultsGroup) Program.get("Loader").call("loadFile", "./tests/data/loaders/ts_AllCondition_plusCondition15_stop500.mht");
			SQResult result;
			SQStats stats;
			
			// verify that correct loader was used
			//assertEquals("TradestationWebReportLoader", loader.getPluginLoaderUsed());
			
			// verify portfolio
			result = strategyResults.getResult(SQConst.SYMBOL_PORTFOLIO);
			stats = result.getStats(SQConst.DIRECTION_ALL, SQConst.PL_IN_MONEY, SQConst.KEY_SAMPLE_ALL);
		
			assertEquals("MHT 2 NumberOfTrades", 1175, stats.getInt("NumberOfTrades"));
			assertEquals("MHT 2 NetProfit", 65680.0, stats.getDouble("NetProfit"));
			
		} catch (Exception e) {
			fail("Exception "+ e.getMessage());
		}
	}
	
	public void testXml() {
		
		try {
			SQResultsGroup strategyResults = (SQResultsGroup) Program.get("Loader").call("loadFile", "./tests/data/loaders/ts_report.xml");
			SQResult result;
			SQStats stats;
			
			// verify that correct loader was used
			//assertEquals("TradestationXmlReportLoader", loader.getPluginLoaderUsed());
			
			// verify portfolio
			result = strategyResults.getResult(SQConst.SYMBOL_PORTFOLIO);
			stats = result.getStats(SQConst.DIRECTION_ALL, SQConst.PL_IN_MONEY, SQConst.KEY_SAMPLE_ALL);
		
			assertEquals("XML 1 NumberOfTrades", 3173, stats.getInt("NumberOfTrades"));
			
		} catch (Exception e) {
			fail("Exception "+ e.getMessage());
		}
	}
}